"use strict";

if (typeof window.connection !== "function") {
  // Not initialized

  // Initialize of the class in global namespace
  window.connection = class connection {
    // Wrap of indicator of the connection
    static wrap = document.getElementById("connection");

    // Indicator of the connection
    static indicator = this.wrap.getElementsByTagName("i")[0];

    // Description of the connection
    static description = this.wrap.getElementsByTagName("small")[0];

    // Statuc of the connection
    static connected = false;

    // Duration of the disconnected status
    static timeout = 0;

    // Instance of the time counter in disconnected status
    static counter;

    /**
     * Initialize status of the connection to socket
     *
     * @param {bool} connected Connected?
     *
     * @return {void}
     */
    static status(connected = false) {
      if (this.indicator instanceof HTMLElement) {
        // Инициализирован индикатор

        if (this.connected = connected) {
          // Connected

          this.wrap.setAttribute("title", "Вы подключены к серверу");

          this.indicator.classList.remove("disconnected");
          this.indicator.classList.add("connected");

          clearInterval(this.counter);
          this.description.innerText = "";
          this.counter = undefined;
          this.timeout = 0;
        } else {
          // Disconnected

          this.wrap.setAttribute("title", "Вы отключены от сервера");

          this.indicator.classList.remove("connected");
          this.indicator.classList.add("disconnected");

          if (typeof this.counter === "undefined") {
            this.counter = setInterval(() => {
              this.timeout += 0.01;
              this.description.innerText = this.timeout.toFixed(2);
            }, 10);
          }
        }
      }
    }
  };
}

// Вызов события: "инициализировано"
document.dispatchEvent(
  new CustomEvent("connection.initialized", {
    detail: { connection: window.connection },
  }),
);
