"use strict";

if (typeof window.core !== "function") {
  // Not initialized

  // Initialize of the class in global namespace
  window.core = class core {
    // Zone
    static zone = window.location.host.split(".")[2];

    // Domain
    static domain = window.location.host.split(".")[1];

    // Subdomain
    static subdomain = window.location.host.split(".")[0];

    // Socket address (xn--e1ajlli это сокет)
    static socket = "wss://xn--e1ajlli.xn--24-mlca2chbdebu6a.xn--p1ai:9502";

    // Instance of connection to the socket
    static connection;

    // Iterval for reconnect
    static interval;

    // Attempts to connect (when core.connection.readyState === 0)
    static attempts = 0;

		// Interval for block
		static block;

    // Page
    static page = window.location.pathname === "/"
      ? "tasks"
      : window.location.pathname.replace(/^.*\//, "");

    // Interface
    static interface = this.subdomain === "xn--80aksgi6f"
      ? "worker"
      : (this.subdomain === "xn--80aj0acchco"
        ? "operator"
        : (this.subdomain === "xn--80aairftm"
          ? "market"
          : (this.subdomain === "xn--80aalqawikqchmc"
            ? "administrator"
            : "worker")));

    /**
     * Заблокировать функцию закрытия всплывающего окна?
     */
    static popup_freeze = false;

    /**
     * Тело всплывающего окна (массив)
     */
    static popup_body = {};

    /**
     * Фильтр: "только цифры, точки и запятые"
     *
     * @param {object} e Event (onkeypress)
     *
     * @return {string}
     */
    static numbers(e) {
      const c = (e.which) ? e.which : e.keyCode;
      return !(c !== 46 && c !== 44 && c > 31 && (c < 48 || c > 57));
    }

    /**
     * Сгенерировать окно выбора действия
     *
     * @param {string} title Верхний колонтинул
     * @param {string} text Основное содержимое окна
     * @param {string} left Содержимое левой кнопки
     * @param {object} left_css Перечисление CSS-классов левой кнопки (массив)
     * @param {function} left_click Действие после нажатия на левую кнопку
     * @param {string} right Содержимое правой кнопки
     * @param {object} right_css Перечисление CSS-классов правой кнопки (массив)
     * @param {function} right_click Действие после нажатия на правую кнопку
     *
     * @return {void}
     */
    static choose = damper(
      (
        title = "Выбор действия",
        text = "",
        left = "Да",
        left_css = ["grass"],
        left_click = () => {},
        right = "Нет",
        right_css = ["clay"],
        right_click = () => {},
      ) => {
        // Инициализация оболочки всплывающего окна
        this.popup_body.wrap = document.createElement("div");
        this.popup_body.wrap.setAttribute("id", "popup");

        // Инициализация всплывающего окна
        const popup = document.createElement("section");
        popup.classList.add("list", "small");

        // Инициализация заголовка всплывающего окна
        const title_h3 = document.createElement("h3");
        title_h3.classList.add("unselectable");
        title_h3.innerText = title;

        // Инициализация оболочки с основной информацией
        const main = document.createElement("section");
        main.classList.add("main");

        // Инициализация колонки
        const column = document.createElement("div");
        column.classList.add("column");

        // Инициализация текста
        const text_p = document.createElement("p");
        text_p.innerText = text;

        // Инициализация строки
        const row = document.createElement("div");
        row.classList.add("row", "buttons");

        // Инициализация левой кнопки
        const left_button = document.createElement("button");
        left_button.classList.add(...left_css);
        left_button.innerText = left;
        left_button.addEventListener("click", left_click);

        // Инициализация правой кнопки
        const right_button = document.createElement("button");
        right_button.classList.add(...right_css);
        right_button.innerText = right;
        right_button.addEventListener("click", right_click);

        // Инициализация окна с ошибками
        this.popup_body.errors = document.createElement("section");
        this.popup_body.errors.classList.add(
          "errors",
          "window",
          "list",
          "calculated",
          "hidden",
        );
        this.popup_body.errors.setAttribute("data-errors", true);

        // Инициализация элемента-тела (оболочки) окна с ошибками
        const errors = document.createElement("section");
        errors.classList.add("body");

        // Инициализация элемента-списка ошибок
        const dl = document.createElement("dl");

        // Инициализация активного всплывающего окна
        const old = document.getElementById("popup");

        if (old instanceof HTMLElement) {
          // Найдено активное окно

          // Деинициализация быстрых действий по кнопкам
          document.removeEventListener("keydown", this.buttons);

          // Сброс блокировки
          this.freeze = false;

          // Удаление активного окна
          old.remove();
        }

        // Запись в документ
        popup.appendChild(title_h3);

        column.appendChild(text_p);

        row.appendChild(left_button);
        row.appendChild(right_button);
        column.appendChild(row);

        main.appendChild(column);
        popup.appendChild(main);

        this.popup_body.wrap.appendChild(popup);
        document.body.appendChild(this.popup_body.wrap);

        errors.appendChild(dl);
        this.popup_body.errors.appendChild(errors);
        this.popup_body.wrap.appendChild(this.popup_body.errors);

        // Инициализация ширины окна с ошибками
        this.popup_body.errors.style.setProperty(
          "--calculated-width",
          popup.offsetWidth + "px",
        );

        // Инициализация переменных для окна с ошибками (12 - это значение gap из div#popup)
        function top(errors) {
          errors.style.setProperty("transition", "0s");
          errors.style.setProperty(
            "--top",
            popup.offsetTop + popup.offsetHeight + 12 + "px",
          );
          setTimeout(() => errors.style.removeProperty("transition"), 100);
        }
        top(this.popup_body.errors);
        const resize = new ResizeObserver(() => top(this.popup_body.errors));
        resize.observe(this.popup_body.wrap);

        // Инициализация функции закрытия всплывающего окна
        const click = () => {
          // Блокировка
          if (this.freeze) return;

          // Удаление всплывающего окна
          this.popup_body.wrap.remove();

          // Удаление статуса активной строки
          row.removeAttribute("data-selected");

          // Деинициализация быстрых действий по кнопкам
          document.removeEventListener("keydown", this.buttons);

          // Сброс блокировки
          this.freeze = false;
        };

        // Инициализация функции добавления функции закрытия всплывающего окна
        const enable = () =>
          this.popup_body.wrap.addEventListener("click", click);

        // Инициализация функции удаления функции закрытия всплывающего окна
        const disable = () =>
          this.popup_body.wrap.removeEventListener("click", click);

        // Первичная активация функции удаления всплывающего окна
        enable();

        // Добавление функции удаления всплывающего окна по событиям
        popup.addEventListener("mouseenter", disable);
        popup.addEventListener("mouseleave", enable);

        // Добавление функции удаления всплывающего окна по кнопкам
        left_button.addEventListener("click", click);
        right_button.addEventListener("click", click);

        // Фокусировка
        right_button.focus();
      },
      300,
    );

    /**
     * Connect to the socket
     *
     * @param {bool|number} interval Connection check interval (ms)
     * @param {function} preprocessing Will be executed every cycle
     * @param {function} onmessage New message
     * @param {function} onopen Connection opened
     * @param {function} onclose Connection closed
     * @param {function} onerror An error has occurred
     *
     * @return {Promise}
     */
    static connect(
      interval = false,
      preprocessing,
      onmessage,
      onopen,
      onclose,
      onerror,
    ) {
      return new Promise((resolve, reject) => {
        try {
          if (typeof interval === "number" && interval > 0) {
            // Connect with automatic reconnect

            if (typeof this.interval === "undefined") {
              this.interval = setInterval(() => {
                preprocessing();
                
                if (
                  !(this.connection instanceof WebSocket) ||
                  (this.connection.readyState === 3 ||
                    this.connection.readyState === 4) ||
                  (this.connection.readyState === 0 && ++this.attempts > 10)
                ) {
                  this.attempts = 0;

                  if (this.connection instanceof WebSocket) {
                    this.connection.close();
                  }

                  this.connection = new WebSocket(this.socket);
                  this.connection.addEventListener("message", (e) => {
                    try {
                      const json = JSON.parse(e.data);

                      if (json.type === "registration") {
                        // Подключение сокета к сессии

                        fetch("/socket/registration", {
                          method: "POST",
                          headers: {
                            "Content-Type": "application/x-www-form-urlencoded",
                          },
                          body: `key=${json.key}`,
                        });
                      }
                    } catch (_e) {}
                  });
                  this.connection.addEventListener("message", onmessage);
                  this.connection.addEventListener("open", onopen);
                  this.connection.addEventListener("close", onclose);
                  this.connection.addEventListener("error", onerror);

                  resolve(this.connection);
                } else resolve(this.connection);
              }, interval);
            }
          } else {
            // Connect without reconnecting

            if (
              !(this.connection instanceof WebSocket) ||
              (this.connection.readyState === 3 ||
                this.connection.readyState === 4)
            ) {
              if (this.connection instanceof WebSocket) this.connection.close();

              this.connection = new WebSocket(this.socket);
              this.connection.addEventListener("message", onmessage);
              this.connection.addEventListener("open", onopen);
              this.connection.addEventListener("close", onclose);
              this.connection.addEventListener("error", onerror);

              resolve(this.connection);
            } else resolve(this.connection);
          }
        } catch (_e) {}
      });
    }

    /**
     * Core is connected to the socket?
		 *
     * @return {bool}
     */
		static connected() {
			return this.connection instanceof WebSocket && this.connection.readyState === 1;
		}
  };
}

// Вызов события: "инициализировано"
document.dispatchEvent(
  new CustomEvent("core.initialized", {
    detail: { core: window.core },
  }),
);
