"use strict";

if (typeof window.settings !== "function") {
  // Not initialized

  // Initialize of the class in global namespace
  window.settings = class settings {
    /**
     * Записать (дампер)
     *
     * Отправляет запрос на сервер для записи в ArangoDB
     *
     * @param {string|number} id Идентификатор (_key)
     * @param {string} value Значение
     *
     * @return {void}
     */
    static write = damper((id, value) => {
      if (
        (typeof id === "string" || typeof id === "number") && typeof value === "string" && value.length > 0
      ) {
        // Получены все обязательные аргументы

        // Запрос к серверу
        fetch(`/settings/${id}/write`, {
          method: "POST",
					headers: {
						"Content-Type": "application/x-www-form-urlencoded",
					},
          body: `value=${value}`,
        });
      }
    }, 400);
  };
}

// Вызов события: "инициализировано"
document.dispatchEvent(
  new CustomEvent("settings.initialized", {
    detail: { settings: window.settings },
  }),
);
